#ifndef __UG_TYPEDEF_H__

#define __UG_TYPEDEF_H__

#define CHAR_PARAM_TYPE_FLAG		1
#define DOUBLE_PARAM_TYPE_FLAG		2
#define INT_PARAM_TYPE_FLAG		3
#define DOUBLE_PARAM_VECTOR_TYPE_FLAG	4
#define INT_PARAM_VECTOR_TYPE_FLAG	5
#define OPT_PARAM_TYPE_FLAG		6
#define OPT_VALUE_PARAM_TYPE_FLAG	7

typedef char CHAR_11[11];
typedef char CHAR_21[21];
typedef char CHAR_25[25];
typedef char CHAR_31[31];
typedef char CHAR_41[41];
typedef char CHAR_51[51];
typedef char CHAR_61[61];
typedef char CHAR_71[71];
typedef char CHAR_81[81];
typedef char CHAR_91[91];
typedef char CHAR_101[101];
typedef char CHAR_111[111];
typedef char CHAR_121[121];
typedef char CHAR_131[131];
typedef char CHAR_133[133];
typedef char CHAR_256[256];
typedef char CHAR_512[512];
typedef char CHAR_1024[1024];
typedef char CHAR_UG_MAX[UG_MAX_CHAR_STRING_LENGTH];

#ifdef _UG_SHORT_INT_
typedef short int INT_;
#else
#ifdef _UG_LONG_INT_
typedef LONG_int INT_;
#else
#ifdef _UG_LONG_LONG_INT_
#define _UG_INT64_	1
typedef LONG_LONG_int INT_;
#else
typedef int INT_;
#endif
#endif
#endif

typedef int int_1d;
typedef int int_2d[2];
typedef int int_3d[3];
typedef int int_4d[4];
typedef int int_5d[5];
typedef int int_6d[6];
typedef int int_7d[7];
typedef int int_8d[8];
typedef int int_9d[9];
typedef int int_10d[10];
typedef int int_11d[11];
typedef int int_12d[12];
typedef int int_13d[13];
typedef int int_14d[14];
typedef int int_15d[15];
typedef int int_16d[16];
typedef int int_17d[17];
typedef int int_18d[18];
typedef int int_19d[19];

typedef INT_ INT_1D;
typedef INT_ INT_2D[2];
typedef INT_ INT_3D[3];
typedef INT_ INT_4D[4];
typedef INT_ INT_5D[5];
typedef INT_ INT_6D[6];
typedef INT_ INT_7D[7];
typedef INT_ INT_8D[8];
typedef INT_ INT_9D[9];
typedef INT_ INT_10D[10];
typedef INT_ INT_11D[11];
typedef INT_ INT_12D[12];
typedef INT_ INT_13D[13];
typedef INT_ INT_14D[14];
typedef INT_ INT_15D[15];
typedef INT_ INT_16D[16];
typedef INT_ INT_17D[17];
typedef INT_ INT_18D[18];
typedef INT_ INT_19D[19];

typedef double DOUBLE_1D;
typedef double DOUBLE_2D[2];
typedef double DOUBLE_3D[3];
typedef double DOUBLE_4D[4];
typedef double DOUBLE_5D[5];
typedef double DOUBLE_6D[6];
typedef double DOUBLE_7D[7];
typedef double DOUBLE_8D[8];
typedef double DOUBLE_9D[9];
typedef double DOUBLE_10D[10];
typedef double DOUBLE_11D[11];
typedef double DOUBLE_12D[12];
typedef double DOUBLE_13D[13];
typedef double DOUBLE_14D[14];
typedef double DOUBLE_15D[15];
typedef double DOUBLE_16D[16];
typedef double DOUBLE_17D[17];
typedef double DOUBLE_18D[18];
typedef double DOUBLE_19D[19];

typedef float FLOAT_1D;
typedef float FLOAT_2D[2];
typedef float FLOAT_3D[3];
typedef float FLOAT_4D[4];
typedef float FLOAT_5D[5];
typedef float FLOAT_6D[6];
typedef float FLOAT_7D[7];
typedef float FLOAT_8D[8];
typedef float FLOAT_9D[9];
typedef float FLOAT_10D[10];
typedef float FLOAT_11D[11];
typedef float FLOAT_12D[12];
typedef float FLOAT_13D[13];
typedef float FLOAT_14D[14];
typedef float FLOAT_15D[15];
typedef float FLOAT_16D[16];
typedef float FLOAT_17D[17];
typedef float FLOAT_18D[18];
typedef float FLOAT_19D[19];

typedef INT_ INT_2X2[2][2];
typedef INT_ INT_2X3[2][3];
typedef INT_ INT_2X4[2][4];
typedef INT_ INT_2X5[2][5];
typedef INT_ INT_2X6[2][6];
typedef INT_ INT_2X7[2][7];
typedef INT_ INT_2X8[2][8];
typedef INT_ INT_2X9[2][9];
typedef INT_ INT_3X2[3][2];
typedef INT_ INT_3X3[3][3];
typedef INT_ INT_3X4[3][4];
typedef INT_ INT_3X5[3][5];
typedef INT_ INT_3X6[3][6];
typedef INT_ INT_3X7[3][7];
typedef INT_ INT_3X8[3][8];
typedef INT_ INT_3X9[3][9];
typedef INT_ INT_4X2[4][2];
typedef INT_ INT_4X3[4][3];
typedef INT_ INT_4X4[4][4];
typedef INT_ INT_4X5[4][5];
typedef INT_ INT_4X6[4][6];
typedef INT_ INT_4X7[4][7];
typedef INT_ INT_4X8[4][8];
typedef INT_ INT_4X9[4][9];
typedef INT_ INT_5X2[5][2];
typedef INT_ INT_5X3[5][3];
typedef INT_ INT_5X4[5][4];
typedef INT_ INT_5X5[5][5];
typedef INT_ INT_5X6[5][6];
typedef INT_ INT_5X7[5][7];
typedef INT_ INT_5X8[5][8];
typedef INT_ INT_5X9[5][9];
typedef INT_ INT_6X2[6][2];
typedef INT_ INT_6X3[6][3];
typedef INT_ INT_6X4[6][4];
typedef INT_ INT_6X5[6][5];
typedef INT_ INT_6X6[6][6];
typedef INT_ INT_6X7[6][7];
typedef INT_ INT_6X8[6][8];
typedef INT_ INT_6X9[6][9];
typedef INT_ INT_7X2[7][2];
typedef INT_ INT_7X3[7][3];
typedef INT_ INT_7X4[7][4];
typedef INT_ INT_7X5[7][5];
typedef INT_ INT_7X6[7][6];
typedef INT_ INT_7X7[7][7];
typedef INT_ INT_7X8[7][8];
typedef INT_ INT_7X9[7][9];
typedef INT_ INT_8X2[8][2];
typedef INT_ INT_8X3[8][3];
typedef INT_ INT_8X4[8][4];
typedef INT_ INT_8X5[8][5];
typedef INT_ INT_8X6[8][6];
typedef INT_ INT_8X7[8][7];
typedef INT_ INT_8X8[8][8];
typedef INT_ INT_8X9[8][9];
typedef INT_ INT_9X2[9][2];
typedef INT_ INT_9X3[9][3];
typedef INT_ INT_9X4[9][4];
typedef INT_ INT_9X5[9][5];
typedef INT_ INT_9X6[9][6];
typedef INT_ INT_9X7[9][7];
typedef INT_ INT_9X8[9][8];
typedef INT_ INT_9X9[9][9];

typedef double DOUBLE_2X2[2][2];
typedef double DOUBLE_2X3[2][3];
typedef double DOUBLE_2X4[2][4];
typedef double DOUBLE_2X5[2][5];
typedef double DOUBLE_2X6[2][6];
typedef double DOUBLE_2X7[2][7];
typedef double DOUBLE_2X8[2][8];
typedef double DOUBLE_2X9[2][9];
typedef double DOUBLE_3X2[3][2];
typedef double DOUBLE_3X3[3][3];
typedef double DOUBLE_3X4[3][4];
typedef double DOUBLE_3X5[3][5];
typedef double DOUBLE_3X6[3][6];
typedef double DOUBLE_3X7[3][7];
typedef double DOUBLE_3X8[3][8];
typedef double DOUBLE_3X9[3][9];
typedef double DOUBLE_4X2[4][2];
typedef double DOUBLE_4X3[4][3];
typedef double DOUBLE_4X4[4][4];
typedef double DOUBLE_4X5[4][5];
typedef double DOUBLE_4X6[4][6];
typedef double DOUBLE_4X7[4][7];
typedef double DOUBLE_4X8[4][8];
typedef double DOUBLE_4X9[4][9];
typedef double DOUBLE_5X2[5][2];
typedef double DOUBLE_5X3[5][3];
typedef double DOUBLE_5X4[5][4];
typedef double DOUBLE_5X5[5][5];
typedef double DOUBLE_5X6[5][6];
typedef double DOUBLE_5X7[5][7];
typedef double DOUBLE_5X8[5][8];
typedef double DOUBLE_5X9[5][9];
typedef double DOUBLE_6X2[6][2];
typedef double DOUBLE_6X3[6][3];
typedef double DOUBLE_6X4[6][4];
typedef double DOUBLE_6X5[6][5];
typedef double DOUBLE_6X6[6][6];
typedef double DOUBLE_6X7[6][7];
typedef double DOUBLE_6X8[6][8];
typedef double DOUBLE_6X9[6][9];
typedef double DOUBLE_7X2[7][2];
typedef double DOUBLE_7X3[7][3];
typedef double DOUBLE_7X4[7][4];
typedef double DOUBLE_7X5[7][5];
typedef double DOUBLE_7X6[7][6];
typedef double DOUBLE_7X7[7][7];
typedef double DOUBLE_7X8[7][8];
typedef double DOUBLE_7X9[7][9];
typedef double DOUBLE_8X2[8][2];
typedef double DOUBLE_8X3[8][3];
typedef double DOUBLE_8X4[8][4];
typedef double DOUBLE_8X5[8][5];
typedef double DOUBLE_8X6[8][6];
typedef double DOUBLE_8X7[8][7];
typedef double DOUBLE_8X8[8][8];
typedef double DOUBLE_8X9[8][9];
typedef double DOUBLE_9X2[9][2];
typedef double DOUBLE_9X3[9][3];
typedef double DOUBLE_9X4[9][4];
typedef double DOUBLE_9X5[9][5];
typedef double DOUBLE_9X6[9][6];
typedef double DOUBLE_9X7[9][7];
typedef double DOUBLE_9X8[9][8];
typedef double DOUBLE_9X9[9][9];

typedef float FLOAT_2X2[2][2];
typedef float FLOAT_2X3[2][3];
typedef float FLOAT_2X4[2][4];
typedef float FLOAT_2X5[2][5];
typedef float FLOAT_2X6[2][6];
typedef float FLOAT_2X7[2][7];
typedef float FLOAT_2X8[2][8];
typedef float FLOAT_2X9[2][9];
typedef float FLOAT_3X2[3][2];
typedef float FLOAT_3X3[3][3];
typedef float FLOAT_3X4[3][4];
typedef float FLOAT_3X5[3][5];
typedef float FLOAT_3X6[3][6];
typedef float FLOAT_3X7[3][7];
typedef float FLOAT_3X8[3][8];
typedef float FLOAT_3X9[3][9];
typedef float FLOAT_4X2[4][2];
typedef float FLOAT_4X3[4][3];
typedef float FLOAT_4X4[4][4];
typedef float FLOAT_4X5[4][5];
typedef float FLOAT_4X6[4][6];
typedef float FLOAT_4X7[4][7];
typedef float FLOAT_4X8[4][8];
typedef float FLOAT_4X9[4][9];
typedef float FLOAT_5X2[5][2];
typedef float FLOAT_5X3[5][3];
typedef float FLOAT_5X4[5][4];
typedef float FLOAT_5X5[5][5];
typedef float FLOAT_5X6[5][6];
typedef float FLOAT_5X7[5][7];
typedef float FLOAT_5X8[5][8];
typedef float FLOAT_5X9[5][9];
typedef float FLOAT_6X2[6][2];
typedef float FLOAT_6X3[6][3];
typedef float FLOAT_6X4[6][4];
typedef float FLOAT_6X5[6][5];
typedef float FLOAT_6X6[6][6];
typedef float FLOAT_6X7[6][7];
typedef float FLOAT_6X8[6][8];
typedef float FLOAT_6X9[6][9];
typedef float FLOAT_7X2[7][2];
typedef float FLOAT_7X3[7][3];
typedef float FLOAT_7X4[7][4];
typedef float FLOAT_7X5[7][5];
typedef float FLOAT_7X6[7][6];
typedef float FLOAT_7X7[7][7];
typedef float FLOAT_7X8[7][8];
typedef float FLOAT_7X9[7][9];
typedef float FLOAT_8X2[8][2];
typedef float FLOAT_8X3[8][3];
typedef float FLOAT_8X4[8][4];
typedef float FLOAT_8X5[8][5];
typedef float FLOAT_8X6[8][6];
typedef float FLOAT_8X7[8][7];
typedef float FLOAT_8X8[8][8];
typedef float FLOAT_8X9[8][9];
typedef float FLOAT_9X2[9][2];
typedef float FLOAT_9X3[9][3];
typedef float FLOAT_9X4[9][4];
typedef float FLOAT_9X5[9][5];
typedef float FLOAT_9X6[9][6];
typedef float FLOAT_9X7[9][7];
typedef float FLOAT_9X8[9][8];
typedef float FLOAT_9X9[9][9];

#endif
